org.optaplanner.core.impl.score.director.incremental

## Interface ConstraintMatchAwareIncrementalScoreCalculator<Solution_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
  All Superinterfaces:
    IncrementalScoreCalculator<Solution_>

      public interface ConstraintMatchAwareIncrementalScoreCalculator<Solution_>
      extends IncrementalScoreCalculator<Solution_>

  Allows a `IncrementalScoreCalculator` to report `ConstraintMatchTotal`s for explaining a score (= which score constraints match for how much) and also for score corruption analysis.
  See Also:
    `IncrementalScoreCalculator`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `Collection<ConstraintMatchTotal>` | `getConstraintMatchTotals()`
    `Map<Object,Indictment>` | `getIndictmentMap()`
    `void` | `resetWorkingSolution(Solution_ workingSolution, boolean constraintMatchEnabled)` Allows for increased performance because it only tracks if constraintMatchEnabled is true.

    - ### Methods inherited from interface org.optaplanner.core.impl.score.director.incremental.IncrementalScoreCalculator

      `afterEntityAdded, afterEntityRemoved, afterVariableChanged, beforeEntityAdded, beforeEntityRemoved, beforeVariableChanged, calculateScore, resetWorkingSolution`

- - ### Method Detail

    - #### resetWorkingSolution

          void resetWorkingSolution(Solution_ workingSolution,
                                    boolean constraintMatchEnabled)

      Allows for increased performance because it only tracks if constraintMatchEnabled is true.

      Every implementation should call `resetWorkingSolution(Solution_, boolean)` and only handle the constraintMatchEnabled parameter specifically (or ignore it).

      Parameters:
        `workingSolution` - never null, to pass to `resetWorkingSolution(Solution_, boolean)`.
        `constraintMatchEnabled` - true if `getConstraintMatchTotals()` or `getIndictmentMap()` might be called.

    - #### getConstraintMatchTotals

          Collection<ConstraintMatchTotal> getConstraintMatchTotals()

      Returns:
        never null
      Throws:
        `IllegalStateException` - if `resetWorkingSolution(Solution_, boolean)`'s constraintMatchEnabled parameter was false
      See Also:
        `ScoreDirector.getConstraintMatchTotals()`

    - #### getIndictmentMap

          Map<Object,Indictment> getIndictmentMap()

      Returns:
        null if it should to be calculated non-incrementally from `getConstraintMatchTotals()`
      Throws:
        `IllegalStateException` - if `resetWorkingSolution(Solution_, boolean)`'s constraintMatchEnabled parameter was false
      See Also:
        `ScoreDirector.getIndictmentMap()`

Copyright © 2006–2019 JBoss by Red Hat. All rights reserved.